package Proyecto;

import java.awt.Dimension;
import javax.swing.JOptionPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import com.csvreader.*;
import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;



public class Gui_help extends javax.swing.JFrame {

    //contructor:
    public Gui_help() {
        initComponents();
        setVentana();
    }

    //<editor-fold defaultstate="collapsed" desc="metodos">
    
    private void visulizarRutas(String text) {
        
        this.ta_general.setText("");
        CsvReader reader= null;
        try {
            reader = new CsvReader(new BufferedReader(new FileReader(new File("./ayuda.csv"))),';');
            reader.readHeaders();
            
            while (reader.readRecord()) {
                if (reader.get(2).contains(text)) {
                    this.ta_general.setText(this.ta_general.getText() + reader.get(1)+"\n");
                }
            }
            
            if (this.ta_general.getText().equals("")) {
                JOptionPane.showMessageDialog(this, "No se ha encontrado ninguna ruta", "No encontrado", JOptionPane.ERROR_MESSAGE);
            }
            
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Gui_help.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Gui_help.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            if (reader != null) {
                reader.close();
            }
        }
        
    }
    
    private String devolverDescript(String item) {
        CsvReader reader= null;
        try {
            reader = new CsvReader(new BufferedReader(new FileReader(new File("./ayuda.csv"))),';');
            reader.readHeaders();
            while (reader.readRecord()) {
                if (reader.get(0).equals(item)) {
                    return reader.get(2);
                }
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Gui_help.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Gui_help.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            if (reader != null) {
                reader.close();
            }
        }
        return null;
    }
    
    private void setVentana() {

        this.setResizable(false);
        this.setPreferredSize(new Dimension(600, 520));
        this.pack();
        this.setLocationRelativeTo(null);
        this.ta_general.setLineWrap(true);
        this.ta_general.setForeground(Color.GREEN);
        modeloTree = new javax.swing.tree.DefaultMutableTreeNode("Indice");
        modelo = new DefaultTreeModel(modeloTree);
        setTree();
        
    }
    
    //Quita un token al StringTokenizer que se le pasa
    private StringTokenizer tonkenMenosUno(StringTokenizer tc, String sep) {
        String tokens = "";
        tc.nextToken();
        for (int i = 0; i < tc.countTokens(); i++) {
            if (i < tc.countTokens()-1) {
                tokens += tc.nextToken()+sep;
            }else{
                tokens+=tc.nextToken();
            }
        }
        return new StringTokenizer(tokens, sep);
        
    }
    
    //Si existe r en ese nodo, devule el index
    private int exiteEn(String n, DefaultMutableTreeNode nodo) {
        DefaultMutableTreeNode next = nodo.getNextNode();
        int cont = 0;
        while (next != null) {
            if (next.toString().equals(n)) {
                return cont;
            }
            next = next.getNextNode();
            cont++;
        }
        return -1;
    }
    
    //Metodo que te crea o añade a una ruta
    private void añadirRuta(StringTokenizer st, DefaultMutableTreeNode nodo) {
        String r = st.nextToken().trim();
        if (st.countTokens()<=1) { // si es el ultimo
            nodo.add(new DefaultMutableTreeNode(r));
        }else{
            int exist = exiteEn(r, nodo);//si existe r en ese nodo, devule el index
             if (exist>=0) {
                 añadirRuta(tonkenMenosUno(st,"-"), (DefaultMutableTreeNode)nodo.getChildAt(exist));
            }else{
                 DefaultMutableTreeNode creado = new DefaultMutableTreeNode(r);
                 nodo.add(creado);
                 añadirRuta(tonkenMenosUno(st,"-"), creado);
             }
        }
        
    }    
    
    private void setTree() {
        CsvReader reader = null;
        
        try {
            reader = new CsvReader(new BufferedReader(new FileReader(new File("./ayuda.csv"))),';');
            reader.readHeaders();
            while (reader.readRecord()) {
                añadirRuta(new StringTokenizer(reader.get(1)+" - "+ reader.get(0), "-"), modeloTree);
            }
            this.jTree1.setModel(modelo);
            
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Gui_help.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Gui_help.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            if(reader != null){
                reader.close();
            }
        }
        
    }
    
//</editor-fold>
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        p_contenido = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        p_buscar = new javax.swing.JPanel();
        tf_pal = new javax.swing.JTextField();
        bt_buscar = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        ta_general = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jSplitPane1.setDividerLocation(200);

        jPanel1.setLayout(new java.awt.BorderLayout());

        p_contenido.setLayout(new java.awt.BorderLayout());

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("ejemp");
        javax.swing.tree.DefaultMutableTreeNode treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("ejemplo2");
        treeNode1.add(treeNode2);
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        p_contenido.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Contenido", p_contenido);

        bt_buscar.setText(">");
        bt_buscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_buscarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout p_buscarLayout = new javax.swing.GroupLayout(p_buscar);
        p_buscar.setLayout(p_buscarLayout);
        p_buscarLayout.setHorizontalGroup(
            p_buscarLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(p_buscarLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(tf_pal, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bt_buscar)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        p_buscarLayout.setVerticalGroup(
            p_buscarLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(p_buscarLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(p_buscarLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tf_pal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(bt_buscar))
                .addContainerGap(459, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Buscar", p_buscar);

        jPanel1.add(jTabbedPane1, java.awt.BorderLayout.PAGE_START);

        jSplitPane1.setLeftComponent(jPanel1);

        ta_general.setColumns(20);
        ta_general.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        ta_general.setRows(5);
        jScrollPane3.setViewportView(ta_general);

        jSplitPane1.setRightComponent(jScrollPane3);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    //<editor-fold defaultstate="collapsed" desc="eventos">
    
    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        JTree tree = (JTree) evt.getSource();
        TreePath s = tree.getSelectionPath();
        String select = "";
        
        try {
             select = String.valueOf(s.getLastPathComponent());
        } catch (Exception e) {
        }
       
        this.ta_general.setText(devolverDescript(select));
        
    }//GEN-LAST:event_jTree1ValueChanged

    private void bt_buscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_buscarActionPerformed
        
        if (!this.tf_pal.getText().isEmpty()) {
            visulizarRutas(tf_pal.getText());
        }else{
            JOptionPane.showMessageDialog(this, "Introduce algo a buscar", "Error", JOptionPane.ERROR_MESSAGE);
            this.tf_pal.requestFocus();
        }
        
    }//GEN-LAST:event_bt_buscarActionPerformed

    
    
    
    
    //</editor-fold>
    
    public static void main(String args[]) {
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Gui_help.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Gui_help.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Gui_help.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Gui_help.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Gui_help().setVisible(true);
            }
        });
    }

    //<editor-fold defaultstate="collapsed" desc="atributos">

    DefaultTreeModel modelo;
    DefaultMutableTreeNode modeloTree;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bt_buscar;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTree jTree1;
    private javax.swing.JPanel p_buscar;
    private javax.swing.JPanel p_contenido;
    private javax.swing.JTextArea ta_general;
    private javax.swing.JTextField tf_pal;
    // End of variables declaration//GEN-END:variables
    //</editor-fold>
}
